//  
//  SoftBank X}[gtHT[rXJxTCg
//  t@XR[h9(SQLite)
//
//  Copyright(c) 2011 SOFTBANK MOBILE Corp. All rights reserved
//

package sqlite.sample;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

public class SQLiteSample {
	private final static String DB_NAME = "sample.db";
	private final static String DB_TABLE = "sample";
	private final static int DB_VERSION = 2;

	private SQLiteDatabase db;

	// RXgN^
	SQLiteSample(Context context) {
		// SQLiteOpenHelperpNXgpăf[^x[X쐬܂
		SQLiteOpenHelperEx helper = new SQLiteOpenHelperEx(context);
		db = helper.getWritableDatabase();
	}

	// R[h̑}
	void writeDB(String str) throws Exception {
		// R[h𒲂ׂ邽߂dbquery\bhɂ
		// ɓK郌R[hCursorIuWFNgƂĎ擾܂
		// querÿ(e[u,J̔z,selectionp[^,
		// selectionp[^̈,groupByp[^,havingp[^,
		// orderByp[^,limitp[^)w肵܂
		Cursor cursor = db.query(DB_TABLE, new String[] { "id", "info" }, null,
				null, null, null, null);
		// 擾R[h擾܂
		int num = cursor.getCount();

		// }郌R[h쐬܂
		// ContentValuesIuWFNg𐶐
		// put()\bhɂăJ̒lݒ肵܂
		// łidɌ݂̃R[hAinfoɂ͈w肵Ă܂
		ContentValues values = new ContentValues();
		values.put("id", Integer.toString(num));
		values.put("info", str);

		// 쐬ContentValuesDB̃\bhinsertɂđ}܂
		// (e[u,NULL,R[h)w肵܂
		db.insert(DB_TABLE, "", values);

	}

	// R[h̍XV
	int updateDB(String target, String str) throws Exception {
		// XV郌R[h쐬܂
		ContentValues values = new ContentValues();
		values.put("id", target);
		values.put("info", str);

		// 쐬ContentValuesDB̃\bhupdateɂčXV܂
		// (e[u,R[h,wherep[^,wherep[^̈)w肵܂
		// ł͈targetƓidR[h̓eXV܂
		return db.update(DB_TABLE, values, "id=" + target, null);

	}

	// R[h̍폜
	int deleteDB(String target) throws Exception {
		// DB̃\bhdeleteɂăR[h̍폜s܂
		// (e[u,wherep[^,J̔z)w肵܂
		// ł͈targetƓidR[h폜܂
		return db.delete(DB_TABLE, "id=" + target, null);
	}

	// R[h̓ǂݍ
	String readDB(String target) throws Exception {
		// DB̃\bhqueryɂăR[h̓ǂݍ݂s܂
		// (e[u,J̔z,selectionp[^,
		// selectionp[^̈,groupByp[^,havingp[^,
		// orderByp[^,limitp[^)w肵܂
		// ł͈targetƓidR[h̓e
		// ߂lƂĕԂ܂

		// targetƓidR[h擾܂
		Cursor cursor = db.query(DB_TABLE, new String[] { "id", "info" }, "id="
				+ target, null, null, null, null);
		// Cursor̎Qƈʒu擪ɈړAڂ̃J̓p(info)
		// 擾A߂lƂĕԂ܂
		cursor.moveToFirst();
		String str = cursor.getString(1);
		cursor.close();
		return str;
	}

	void clearDB() throws Exception {
		// SQLsăe[u폜܂
		String sql = "drop table " + DB_TABLE;
		db.execSQL(sql);
	}

	void createDB() throws Exception {
		// SQLsăe[u쐬܂
		String sql = "create table if not exists " + DB_TABLE
				+ "(id text primary key, info text)";
		db.execSQL(sql);
	}

	public class SQLiteOpenHelperEx extends SQLiteOpenHelper {
		// RXgN^
		public SQLiteOpenHelperEx(Context context) {
			super(context, DB_NAME, null, DB_VERSION);
		}

		@Override
		public void onCreate(SQLiteDatabase db) {
			// e[u̍쐬
			// SQLsăe[u쐬܂
			// ł́Ae[uDB_TABLEAJ͕id(L[)A
			// infoƂȂĂ܂
			String sql = "create table if not exists " + DB_TABLE
					+ "(id text primary key, info text)";
			db.execSQL(sql);
		}

		@Override
		public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
			// f[^x[X̃AbvO[h
			// f[^x[X̃o[WオƂɎs郁\bhł
			// f[^x[X̍\ςꍇȂǂɎgp܂
			// ł́Ae[u蒼Ă܂
			db.execSQL("drop table if exists " + DB_TABLE);
			onCreate(db);
		}
	}

}
